<template>
  <v-container>
    <v-row dense>
      <v-col cols="12">
        <v-card>
          <div class="d-flex flex-no-wrap">
            <v-avatar class="ma-3" size="300" tile>
              <v-img
                :src="
                  movie.Poster === 'N/A'
                    ? 'https://via.placeholder.com/300.jpg'
                    : movie.Poster
                "
                aspect-ratio="0.95"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>

            <div>
              <v-card-title primary-title
                >{{ movie.Title }} ({{ movie.Year }})
              </v-card-title>

              <v-card-text>
                <p>{{ movie.Plot }}</p>
                <h3>Actors:</h3>
                <p>{{ movie.Actors }}</p>
                <h3>Awards:</h3>
                <p>{{ movie.Awards }}</p>
                <h3>Genre:</h3>
                <p>{{ movie.Genre }}</p>
              </v-card-text>
            </div>
          </div>
          <div>
            <v-card-actions class="justify-center">
              <v-dialog v-model="dialog" width="500">
                <template v-slot:activator="{ on }">
                  <v-btn text color="green" v-on="on">Ratings</v-btn>
                </template>
                <v-card>
                  <v-card-title class="headline grey lighten-2" primary-title>
                    Ratings
                  </v-card-title>

                  <v-card-text>
                    <table style="width:100%" border="1">
                      <tr>
                        <th>Source</th>
                        <th>Ratings</th>
                      </tr>
                      <tr v-for="(rating, index) in this.ratings" :key="index">
                        <td align="center">{{ ratings[index].Source }}</td>
                        <td align="center">
                          <v-rating
                            :half-increments="true"
                            :value="ratings[index].Value"
                          ></v-rating>
                        </td>
                      </tr>
                    </table>
                  </v-card-text>

                  <v-divider></v-divider>

                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="dialog = false">
                      OK
                    </v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
              <v-btn text color="green" @click="back">back</v-btn>
            </v-card-actions>
          </div>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
export default {
  name: 'BaseMovieCard',
  props: {
    movie: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      dialog: false
    };
  },
  computed: {
    ratings() {
      let ratings = this.movie.Ratings;

      ratings.forEach(function(element) {
        element.Value = parseFloat(element.Value.split(/\/|%/)[0]);
        element.Value =
          element.Value <= 10 ? element.Value / 2 : element.Value / 20;
      });

      return ratings;
    }
  },
  methods: {
    back() {
      this.$router.go(-1);
    }
  }
};
</script>
